#-*- coding: utf-8 -*-

# pyPastebin is a simple application that helps you
# to send simply a command output or a file content 
# to paste it on a pastebin service
#Copyright (C) <2008>  <Marco Buccini>
#This program is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.

#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with this program.  If not, see <http://www.gnu.org/licenses/>.



import urllib2
from random import choice

# =========== Import of internal packages =========#
# import here some internal packages, as internal
# modules

from lib.ClientForm import ClientForm



# ================= End of import =================#


class PasteModel(object):
    """
    This is the Model of a Paste object. 
    You must inherit from this object to create or 
    insert another pastebin (service) object.
    
    For example RafbPaste inherits from this object
    and defines some methods and variables, but it needs
    self.forms.
    Then you've to choose the host, that for default is RafbPaste
    
    """
    
    def __init__(self, host):

        self.request = urllib2.Request( host )
        self.change_ua()
        response = urllib2.urlopen(self.request)
        self.forms = ClientForm.ParseResponse(response, backwards_compat=False)
        self.form = {}
        response.close()
        #__slots__ = ['self.request', 'response', 'self.forms']
    
    def change_ua(self):
        user_agents = [
                        'Mozilla/5.0',
                        'Opera/9.25',
                        'Mozilla/4.0',
                        'Lynx/2.8.5rel.1'
                        ]
        self.request.add_header('User-Agent', choice(user_agents))
    
    def _get_form(self):
        return self.forms[0]
        
    def get_data_form(self):
        return self.form

    def submit_data(self, form):
        #return form.click_request_data()
        return urllib2.urlopen(form.click()).read()

    def __setitem__(self, key, value):
        self.form[key] = value

    def __getitem__(self, key):
        return self.form[key]
        

