#-*- coding: utf-8 -*-

# pyPastebin is a simple application that helps you
# to send simply a command output or a file content
# to paste it on a pastebin service
#Copyright (C) <2008 - 2009>  <Marco Buccini>
#This program is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.

#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with this program.  If not, see <http://www.gnu.org/licenses/>.


# =========== Import of internal packages =========#
# import here some internal packages, as internal
# modules

from lib.BeautifulSoup import BeautifulSoup
from lib.ClientForm import ClientForm

# ================= End of import =================#

from BasePaste import PasteModel

#dpaste engine
class Dpaste(PasteModel):

    host = "http://dpaste.com"

    def __init__(self, nick, desc, lang, text):
        PasteModel.__init__(self, self.host)
        self.nick = nick
        self.desc = desc
        self.text = text
        self.form = self._get_form()
        self.form['poster'] = self.nick
        self.form['title'] = self.desc
        self.form['content'] = text
        try:
            self.form['language'] = [lang.title()]
        except ClientForm.ItemNotFoundError:
            self.form['language'] = ['']
            
    def parse(self, data):
        # data is provided as :
        # <html> <head> <title> Dpaste: #NUMID </title> ... </head></html>
        title = BeautifulSoup(data).html.head.title.string.split(":")[1]
        id_page = title.split("#")[1]
        return "URL: %s/%s" % (self.host, id_page)
