#-*- coding: utf-8 -*-

# pyPastebin is a simple application that helps you
# to send simply a command output or a file content 
# to paste it on a pastebin service
#Copyright (C) <2008 - 2009>  <Marco Buccini>
#This program is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.

#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with this program.  If not, see <http://www.gnu.org/licenses/>.



import sys

# ========= Internal packages import =====#
# Import here some internal packages for
# paste service
from PopenObj import PopenObj

from DPaste import Dpaste
from NoPaste import NoPaste
from UbuntuPaste import UbuntuPaste

# ========== End of import ===============#

paste_engines = {
                'dpaste': Dpaste,
                'nopaste': NoPaste,
                'ubuntu': UbuntuPaste,
                }

class pyPasteCmdLine(object):

    """
    This class provides the command line for the application.
    """
    def __init__(self, nick,  description, lang,
                       paste, cmd, infile, verbose=False):
                       
        self.paste = paste
        self.nick = nick if nick else "Anonymous"
        self.description = description
        self.lang = lang
        self.cmd = cmd
        self.infile = infile
        self.verbose = verbose
                
        try:
            self.pipe = PopenObj(self.cmd, self.infile, self.verbose)
        except OSError, e:
            print "An error occurred while I was trying to produce output: %s" % e
            sys.exit()
        else:
            self.text = self.pipe.show_output()
        
        try:
            self.pypaste = paste_engines[self.paste](nick=self.nick,
                                    desc=self.description, lang=self.lang,
                                    text=self.text)
        except IOError, e:
            print "Error: %s" %e                                           
            sys.exit()
        except KeyError:
            print "You must specify a paste service!"
            sys.exit()
        
    
    def paste_now(self):
        if self.pipe.is_verbose():
            print self.text
            
        form = self.pypaste.get_data_form()
        page = self.pypaste.submit_data(form)
        return  self.pypaste.parse(page)
        
